"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertFindResults = exports.find = void 0;
const value_1 = require("../value");
const solver_1 = require("../solver");
const ty_1 = __importStar(require("@xieyuheng/ty"));
const ut = __importStar(require("../ut"));
function find(goals, varSchemas, opts = {}) {
    const vars = Object.keys(varSchemas).map((name) => new value_1.Var(name));
    const varEntries = vars.map((v) => [v.name, v]);
    const v = value_1.Var.createVarFinder(new Map(varEntries));
    const searching = solver_1.Solver.forGoals(goals(v));
    const solutions = searching.solve({ limit: opts.limit });
    const results = [];
    for (const subst of solutions) {
        const result = subst.reify(Object.fromEntries(varEntries));
        try {
            results.push(ty_1.default.object(varSchemas).validate(result));
        }
        catch (error) {
            if (error instanceof ty_1.Errors.InvalidData && error.data instanceof value_1.Var) {
                // NOTE Ok
            }
            else {
                throw error;
            }
        }
    }
    return results;
}
exports.find = find;
function assertFindResults(goals, varSchemas, results, opts = {}) {
    const found = find(goals, varSchemas, { limit: opts.limit });
    if (!ut.equal(found, results)) {
        throw new Error([
            "I expect found to be equal to the given results,",
            "but they are not the equal.",
            `  found results: ${JSON.stringify(found)}`,
            `  given results: ${JSON.stringify(results)}`,
        ].join("\n"));
    }
}
exports.assertFindResults = assertFindResults;
