"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.query = void 0;
const value_1 = require("../value");
const solver_1 = require("../solver");
function query(goals, varNames, opts = {}) {
    varNames = Array.from(new Set(varNames)); // NOTE dedup
    const vars = varNames.map((name) => new value_1.Var(name));
    const varEntries = vars.map((v) => [v.name, v]);
    const v = value_1.Var.createVarFinder(new Map(varEntries));
    const searching = solver_1.Solver.forGoals(goals(v));
    const solutions = searching.solve({ limit: opts.limit });
    const results = solutions.map((subst) => subst.reify(Object.fromEntries(varEntries)));
    return results;
}
exports.query = query;
