"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GoalQueue = void 0;
class GoalQueue {
    constructor(subst, goals) {
        this.subst = subst;
        this.goals = goals;
    }
    step() {
        const goal = this.goals.shift();
        if (goal === undefined)
            return null;
        const queues = goal.evaluate(this.subst);
        return queues.map(
        // NOTE about searching again
        // push front |   depth first
        // push back  | breadth first
        // NOTE `concat` is like push back
        (queue) => new GoalQueue(queue.subst, this.goals.concat(queue.goals)));
    }
}
exports.GoalQueue = GoalQueue;
