"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Relation = void 0;
const goal_1 = require("../goal");
const goal_queue_1 = require("../goal-queue");
const Clauses = __importStar(require("../clauses"));
const value_1 = require("../value");
const ctx_1 = require("../ctx");
class Relation extends goal_1.Goal {
    constructor(opts) {
        super();
        this.table = opts.table;
        this.data = opts.data;
    }
    evaluate(subst) {
        const queues = [];
        for (const clause of this.table.clauses) {
            const data = value_1.freshenValue(clause.data);
            const newSubst = subst.unify(data, this.data);
            if (newSubst !== null) {
                if (clause instanceof Clauses.Fact) {
                    queues.push(new goal_queue_1.GoalQueue(newSubst, []));
                }
                else if (clause instanceof Clauses.Rule) {
                    const v = value_1.Var.createVarFinder(value_1.Var.extractVarMap(data));
                    const ctx = new ctx_1.Ctx(newSubst);
                    queues.push(new goal_queue_1.GoalQueue(newSubst, clause.premises(v, ctx)));
                }
                else {
                    throw new Error(`Unknown clause type: ${clause.constructor.name}`);
                }
            }
        }
        return queues;
    }
}
exports.Relation = Relation;
