"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Unifiable = void 0;
const goal_1 = require("../goal");
const goal_queue_1 = require("../goal-queue");
class Unifiable extends goal_1.Goal {
    constructor(left, right) {
        super();
        this.left = left;
        this.right = right;
    }
    static create(left, right) {
        return new Unifiable(left, right);
    }
    evaluate(subst) {
        const newSubst = subst.unify(this.left, this.right);
        if (newSubst !== null) {
            return [new goal_queue_1.GoalQueue(newSubst, [])];
        }
        else {
            return [];
        }
    }
}
exports.Unifiable = Unifiable;
