"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const value_1 = require("../value");
const subst_1 = require("../subst");
{
    const x = value_1.v `x`;
    const subst = subst_1.Subst.create().unify(123, x);
    assert_1.default(subst);
    subst.assertFound(x, 123);
}
{
    const x = value_1.v `x`;
    const subst = subst_1.Subst.create().unify({ name: "xieyuheng" }, x);
    assert_1.default(subst);
    subst.assertFound(x, { name: "xieyuheng" });
}
{
    const x = value_1.v `x`;
    const subst = subst_1.Subst.create().unify({ name: "xieyuheng" }, { name: x });
    assert_1.default(subst);
    subst.assertFound(x, "xieyuheng");
}
{
    const x = value_1.v `x`;
    const y = value_1.v `y`;
    const subst = subst_1.Subst.create().unify({ name: "xieyuheng", items: ["a", "b", "c"] }, { name: x, items: ["a", y, "c"] });
    assert_1.default(subst);
    subst.assertFound(x, "xieyuheng");
    subst.assertFound(y, "b");
}
