import { Logical, VarFinder } from "../value";
import { Ctx } from "../ctx";
import { Clause } from "../clause";
import { Goal } from "../goal";
import { Schema } from "@xieyuheng/ty";
export declare class Table<T> {
    clauses: Array<Clause<T>>;
    name: string;
    schema: Schema<T>;
    constructor(opts: {
        name: string;
        schema: Schema<T>;
    });
    i(data: Logical<T>, premises?: (v: VarFinder, ctx: Ctx) => Array<Goal>): void;
    o(data: Logical<T>): Goal;
    query(data: Logical<T>, opts?: {
        limit?: number;
    }): Array<Logical<T>>;
    find<R>(data: Logical<T>, varSchemas: {
        [P in keyof R]: Schema<R[P]>;
    }, opts?: {
        limit?: number;
    }): Array<R>;
    get(data: Logical<T>): Logical<T> | undefined;
    assert(data: Logical<T>): void;
    assertNot(data: Logical<T>): void;
    assertQueryResults(data: Logical<T>, results: Array<Logical<T>>): void;
}
