"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.v = exports.Var = void 0;
const value_1 = require("../value");
class Var {
    constructor(name) {
        this.id = Var.counter++;
        this.name = name;
    }
    // NOTE side-effect on map
    static createVarFinder(map) {
        return (strs) => {
            const found = map.get(strs[0]);
            if (found !== undefined) {
                return found;
            }
            else {
                const variable = new Var(strs[0]);
                map.set(variable.name, variable);
                return variable;
            }
        };
    }
    static extractVarMap(value) {
        if (value instanceof Var) {
            return new Map([[value.name, value]]);
        }
        else if (value instanceof Array) {
            const map = new Map();
            for (const e of value) {
                for (const [name, v] of this.extractVarMap(e)) {
                    map.set(name, v);
                }
            }
            return map;
        }
        else if (value_1.isObject(value)) {
            const map = new Map();
            for (const k in value) {
                for (const [name, v] of this.extractVarMap(value[k])) {
                    map.set(name, v);
                }
            }
            return map;
        }
        else {
            return new Map();
        }
    }
}
exports.Var = Var;
Var.counter = 0;
function v(strs) {
    const [name] = strs;
    return new Var(name);
}
exports.v = v;
